//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_color6  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    SF           = 1;
extern int    RSIPeriod    = 32;
extern int    RSIPrice     = PRICE_CLOSE;
extern double OmaSpeed     = 1.5;
extern bool   OmaAdaptive  = true;
extern double WP           = 2;
extern int    Filter       = 1;
extern int    FilterMode   = MODE_LWMA;
extern bool   ColorOnSlope = false;
extern bool   Interpolate  = true; 

extern bool   arrowsVisible       = false;
extern string arrowsIdentifier    = "OmaQqeArrows1";
extern double arrowsDisplacement  = 1.0;
extern color  arrowsUpColor       = LightSeaGreen;
extern color  arrowsDnColor       = SandyBrown;
extern int    arrowsUpCode        = 225;
extern int    arrowsDnCode        = 226;
extern int    arrowsUpSize        = 1;
extern int    arrowsDnSize        = 1;

extern bool   alertsOn            = false;
extern bool   alertsOnSlope       = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;

//
//
//
//
//

double TrendU[];
double TrendDa[];
double TrendDb[];
double RsiMa[];
double RsiMaDa[];
double RsiMaDb[];
double TrendQqe[];
double TrendQqs[];
double emas[][3];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,RsiMa);    SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,RsiMaDa);  SetIndexLabel(1, "QQE down");
   SetIndexBuffer(2,RsiMaDb);  SetIndexLabel(2, "QQE down");
   SetIndexBuffer(3,TrendU);   SetIndexLabel(1, "QQE trend up");
   SetIndexBuffer(4,TrendDa);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(5,TrendDb);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(6,TrendQqe);
   SetIndexBuffer(7,TrendQqs);
   
   //
   //
   //
   //
   //
       
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" One more average RSI QQE ("+SF+","+RSIPeriod+","+Filter+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iEma 0
#define iEmm 1
#define iQqe 2

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = Bars-counted_bars;
           if (returnBars) { RsiMa[0] = limit+1; return(0); }
           if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars); 
           if (TrendQqe[limit]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
           if (TrendQqs[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      double alpha1 = 2.0/(SF+1.0);
      double alpha2 = 2.0/(RSIPeriod*2.0);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {  
         double tRsi = iRsi(iMA(NULL,0,Filter,0,FilterMode,RSIPrice,i),RSIPeriod,OmaSpeed,OmaAdaptive,i,0);
         RsiMa[i]   = RsiMa[i+1] + alpha1*(tRsi - RsiMa[i+1]);
         emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
         emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma] - emas[r-1][iEmm]);

         //
         //
         //
         //
         //

         double rsi0 = RsiMa[i];
         double rsi1 = RsiMa[i+1];
         double dar  = emas[r  ][iEmm]*WP;
         double tr   = emas[r-1][iQqe];
         double dv   = tr;
   
            if (rsi0 < tr) { tr = rsi0 + dar; if ((rsi1 < dv) && (tr > dv)) tr = dv; }
            if (rsi0 > tr) { tr = rsi0 - dar; if ((rsi1 > dv) && (tr < dv)) tr = dv; }
         
         //
         //
         //
         //
         //
         
         TrendU[i]     = tr;
         emas[r][iQqe] = tr;
         TrendDa[i]    = EMPTY_VALUE;
         TrendDb[i]    = EMPTY_VALUE;
         RsiMaDa[i]    = EMPTY_VALUE;
         RsiMaDb[i]    = EMPTY_VALUE;
         TrendQqe[i]   = TrendQqe[i+1];
         TrendQqs[i]   = TrendQqs[i+1];

            if (tr < RsiMa[i]  ) TrendQqs[i] =  1;
            if (tr > RsiMa[i]  ) TrendQqs[i] = -1;
            if (ColorOnSlope)
            {            
               if (RsiMa[i]>RsiMa[i+1]) TrendQqe[i] =  1;
               if (RsiMa[i]<RsiMa[i+1]) TrendQqe[i] = -1;
            }
            else TrendQqe[i] = TrendQqs[i];
            if (TrendQqe[i] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
            if (TrendQqs[i] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
         manageArrow(i);            
      }
      manageAlerts();          
   return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          RsiMa[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,OmaSpeed,OmaAdaptive,WP,Filter,FilterMode,ColorOnSlope,0,y);
          TrendU[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,OmaSpeed,OmaAdaptive,WP,Filter,FilterMode,ColorOnSlope,3,y);
          TrendQqe[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,OmaSpeed,OmaAdaptive,WP,Filter,FilterMode,ColorOnSlope,6,y);
          TrendQqs[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,OmaSpeed,OmaAdaptive,WP,Filter,FilterMode,ColorOnSlope,7,y);
          TrendDa[i]    = EMPTY_VALUE;
          TrendDb[i]    = EMPTY_VALUE;
          RsiMaDa[i]    = EMPTY_VALUE;
          RsiMaDb[i]    = EMPTY_VALUE;
            
          //
          //
          //
          //
          //
       
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int x = 1; x < n; x++)
             {
                RsiMa[i+x]  = RsiMa[i]  + (RsiMa[i+n]  - RsiMa[i] ) * x/n;
                TrendU[i+x] = TrendU[i] + (TrendU[i+n] - TrendU[i]) * x/n;
             }               
   }
   for (i=limit; i>=0; i--)
   {
      if (TrendQqe[i] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
      if (TrendQqs[i] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
   }      
   manageAlerts();   
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, double speed, bool adaptive, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*3; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
         double chng   = workRsi[r][_price]-workRsi[r-1][_price];
         double changn = iOma(        chng ,period,speed,adaptive,i,instanceNo*2+0);
         double changa = iOma(MathAbs(chng),period,speed,adaptive,i,instanceNo*2+1);
            if (changn != 0)
                  return(MathMin(MathMax(50.0*(changn/MathMax(changa,0.0000001)+1.0),0),100));
            else  return(50.0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][14];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      ObjectDelete(arrowsIdentifier+":"+Time[i]);
      if (TrendQqs[i]!=TrendQqs[i+1])
      {
         if (TrendQqs[i] == 1) drawArrow("",i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
         if (TrendQqs[i] ==-1) drawArrow("",i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(string add, int i,color theColor,int theCode,int theSize, bool up)
{
   string name = arrowsIdentifier+":"+add+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,   theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize);      
         
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsDisplacement * gap);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && TrendQqe[whichBar] != TrendQqe[whichBar+1])
         {
            if (TrendQqe[whichBar] ==  1) doAlert(time1,mess1,whichBar," OMA QQE sloping UP");
            if (TrendQqe[whichBar] == -1) doAlert(time1,mess1,whichBar," OMA QQE sloping DOWN");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && TrendQqs[whichBar] != TrendQqs[whichBar+1])
         {
            if (TrendQqs[whichBar] ==  1) doAlert(time2,mess2,whichBar," OMA QQE crossed signal line UP");
            if (TrendQqs[whichBar] == -1) doAlert(time2,mess2,whichBar," OMA QQE crossed signal line DOWN");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," OMA QQE "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}